# -*- coding: UTF-8 -*-
#
# Выполнение полученного из сообщения скрипта
#

import backupFile
import logger
import os
import status
import tempfile
import writetofile

log = logger.getLogger()
tmpPath = tempfile.gettempdir()     # куда сохранить скрипт
fileName = 'script'  # как будет называться скрипт
if os.name == 'nt':
    fileName = 'script.bat'
elif os.name == 'posix':
    fileName = 'script.sh'


def main(message):
    # Получаем тело сообщения
    log.info('Получаем тело сообщения')
    script = '%s'
    if os.name == 'posix':
        script = '#!/bin/bash \n\n%s'
    script = script % message.content
    if message.content is None:
        mess = 'Тело скрипта не указано в теле сообщения.'
        log.warning(mess)
        return status.errorExecScript, mess
    else:
        writetofile.main(script, tmpPath, fileName)
        path = os.path.join(tmpPath, fileName)
        log.info('Запускаем полученный скрипт - %s' % path)
        result = 0
        if os.name == 'nt':
            result = os.spawnv(os.P_WAIT, path, [path])
        elif os.name == 'posix':
            result = os.spawnlp(os.P_WAIT, path, "")
        backupFile.archive(path, 'scripts')
        if result == 0:
            return status.OK, 'Команда выполнена.'
        else:
            mess = 'Не удалось выполнить скрипт'
            log.error(mess)
            return status.errorExecScript, mess


def execute(script):
    """
    В методе вместо subprocess.Popen(...) используется os.system(...)
    Это сделано специально, т.к. Popen порой лочится,
    а параметра timeout в методе communicate нет в версии python2.7.X
    """
    scriptName = 'script_from_cs.sh'
    writetofile.main(script, tmpPath, scriptName)
    path = os.path.normpath(tmpPath + '/' + scriptName)
    log.info('Запускаем полученный скрипт - %s' % path)
    os.system(path + ' 2>/tmp/script_error 1>/tmp/script_output')
    backupFile.archive(path, 'scripts')
    with open('/tmp/script_error', 'r') as errorFile:
        err = errorFile.read()
    with open('/tmp/script_output', 'r') as outputFile:
        out = outputFile.read()
    result = {'err': err, 'out': out}
    log.info('Результат выполнения скрипта: %s' % result)
    return result
